// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from espeak_interfaces:msg/Sentence.idl
// generated code does not contain a copyright notice

#ifndef ESPEAK_INTERFACES__MSG__DETAIL__SENTENCE__FUNCTIONS_H_
#define ESPEAK_INTERFACES__MSG__DETAIL__SENTENCE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "espeak_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "espeak_interfaces/msg/detail/sentence__struct.h"

/// Initialize msg/Sentence message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * espeak_interfaces__msg__Sentence
 * )) before or use
 * espeak_interfaces__msg__Sentence__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__Sentence__init(espeak_interfaces__msg__Sentence * msg);

/// Finalize msg/Sentence message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__Sentence__fini(espeak_interfaces__msg__Sentence * msg);

/// Create msg/Sentence message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * espeak_interfaces__msg__Sentence__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
espeak_interfaces__msg__Sentence *
espeak_interfaces__msg__Sentence__create();

/// Destroy msg/Sentence message.
/**
 * It calls
 * espeak_interfaces__msg__Sentence__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__Sentence__destroy(espeak_interfaces__msg__Sentence * msg);


/// Initialize array of msg/Sentence messages.
/**
 * It allocates the memory for the number of elements and calls
 * espeak_interfaces__msg__Sentence__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
bool
espeak_interfaces__msg__Sentence__Sequence__init(espeak_interfaces__msg__Sentence__Sequence * array, size_t size);

/// Finalize array of msg/Sentence messages.
/**
 * It calls
 * espeak_interfaces__msg__Sentence__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__Sentence__Sequence__fini(espeak_interfaces__msg__Sentence__Sequence * array);

/// Create array of msg/Sentence messages.
/**
 * It allocates the memory for the array and calls
 * espeak_interfaces__msg__Sentence__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
espeak_interfaces__msg__Sentence__Sequence *
espeak_interfaces__msg__Sentence__Sequence__create(size_t size);

/// Destroy array of msg/Sentence messages.
/**
 * It calls
 * espeak_interfaces__msg__Sentence__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_espeak_interfaces
void
espeak_interfaces__msg__Sentence__Sequence__destroy(espeak_interfaces__msg__Sentence__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ESPEAK_INTERFACES__MSG__DETAIL__SENTENCE__FUNCTIONS_H_
