// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from espeak_interfaces:msg/Sentence.idl
// generated code does not contain a copyright notice
#include "espeak_interfaces/msg/detail/sentence__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `text`
#include "rosidl_runtime_c/string_functions.h"
// Member `settings`
#include "espeak_interfaces/msg/detail/voice_settings__functions.h"

bool
espeak_interfaces__msg__Sentence__init(espeak_interfaces__msg__Sentence * msg)
{
  if (!msg) {
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__init(&msg->text)) {
    espeak_interfaces__msg__Sentence__fini(msg);
    return false;
  }
  // settings
  if (!espeak_interfaces__msg__VoiceSettings__init(&msg->settings)) {
    espeak_interfaces__msg__Sentence__fini(msg);
    return false;
  }
  return true;
}

void
espeak_interfaces__msg__Sentence__fini(espeak_interfaces__msg__Sentence * msg)
{
  if (!msg) {
    return;
  }
  // text
  rosidl_runtime_c__String__fini(&msg->text);
  // settings
  espeak_interfaces__msg__VoiceSettings__fini(&msg->settings);
}

espeak_interfaces__msg__Sentence *
espeak_interfaces__msg__Sentence__create()
{
  espeak_interfaces__msg__Sentence * msg = (espeak_interfaces__msg__Sentence *)malloc(sizeof(espeak_interfaces__msg__Sentence));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(espeak_interfaces__msg__Sentence));
  bool success = espeak_interfaces__msg__Sentence__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
espeak_interfaces__msg__Sentence__destroy(espeak_interfaces__msg__Sentence * msg)
{
  if (msg) {
    espeak_interfaces__msg__Sentence__fini(msg);
  }
  free(msg);
}


bool
espeak_interfaces__msg__Sentence__Sequence__init(espeak_interfaces__msg__Sentence__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  espeak_interfaces__msg__Sentence * data = NULL;
  if (size) {
    data = (espeak_interfaces__msg__Sentence *)calloc(size, sizeof(espeak_interfaces__msg__Sentence));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = espeak_interfaces__msg__Sentence__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        espeak_interfaces__msg__Sentence__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
espeak_interfaces__msg__Sentence__Sequence__fini(espeak_interfaces__msg__Sentence__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      espeak_interfaces__msg__Sentence__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

espeak_interfaces__msg__Sentence__Sequence *
espeak_interfaces__msg__Sentence__Sequence__create(size_t size)
{
  espeak_interfaces__msg__Sentence__Sequence * array = (espeak_interfaces__msg__Sentence__Sequence *)malloc(sizeof(espeak_interfaces__msg__Sentence__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = espeak_interfaces__msg__Sentence__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
espeak_interfaces__msg__Sentence__Sequence__destroy(espeak_interfaces__msg__Sentence__Sequence * array)
{
  if (array) {
    espeak_interfaces__msg__Sentence__Sequence__fini(array);
  }
  free(array);
}
